> ## Documentation Index
> Fetch the complete documentation index at: https://help.commbox.io/llms.txt
> Use this file to discover all available pages before exploring further.
# Create Child Object
> This API creates a message (child) in a conversation (object) on behalf of the agent, sending it to the customer, or on behalf of the customer, displaying it to the agent.
The API returns the new child’s ID.
Required path parameters include the Stream (channel) ID and the Object (conversation) ID.
Required body parameters for a message on behalf of the customer:
a) The data “Type” see Enum at https://www.commbox.io/api/#section/Enums/ObjectType
b) UserStreamProviderId – the email or phone number of the person you are sending the message on their behalf.
c) UserStreamProviderType of the channel. See Enum at https://www.commbox.io/api/#section/Enums/StreamProviderType
d) The messages
Required body parameters for a message on behalf of the agent:
a) The data “Type” - See Enum at https://www.commbox.io/api/#section/Enums/ObjectType
b) Add this Boolean field 'IsManager': true,
c) Enter the agent’s user ID 'UserIdentity' : 34168,
Get the agent's User ID by using the Get Managers API https://api.commbox.io/managers
d) UserStreamProviderId – the email or phone number of the person you are sending the message on their behalf.
e) UserStreamProviderType of the channel. See Enum at https://www.commbox.io/api/#section/Enums/StreamProviderType
f) The messages
**Note:** After 24 hours from last sent message, APIs messages sent to customers will be blocked by WhatsApp.
POST /streams/STREAM_ID/objects/OBJECT_ID/child
POST /streams/STREAM_ID/objects/STREAM_PROVIDER_ID/STREAM_PROVIDER_TYPE/child
## OpenAPI
````json POST /streams/{STREAM_ID}/objects/{OBJECT_ID}/child
{
"openapi": "3.0.3",
"info": {
"title": "CommBox API",
"x-logo": {
"url": "https://www.commbox.io/logo/commbox_logo_large.png"
},
"version": "2.07",
"termsOfService": "https://www.commbox.io/end-user-license-agreement-eula/",
"contact": {
"name": "commbox",
"url": "https://www.commbox.io",
"email": "contactus@commbox.io"
}
},
"servers": [
{
"url": "https://api.commbox.io/",
"description": "Production server"
}
],
"security": [
{
"BearerAuth": []
}
],
"tags": [
{
"name": "Core",
"description": "
Systemwide verification"
},
{
"name": "Objects",
"description": "
Objects are conversations between the AI Agent or the human agent and the customers, where each segment of the conversation is referred to as a Child. Every conversation must have a designated Stream – a communication channel such as Chat, Email, Text/SMS, etc., through which the conversation takes place.
The Object APIs category concentrates on a specific conversation, where the Stream is part of the identifying parameters. In contrast, the Streams APIs category, the Channel is the focal point of the request, and the objects and users are the filtering aspects."
},
{
"name": "Media",
"description": "Converting media files to Base64"
},
{
"name": "AI Services",
"description": "APIs that provide AI capabilities by the platform. "
},
{
"name": "Streams",
"description": "
Streams are communication channels used in CommBox, such as Chat, WhatsApp, SMS/Text, etc. In the Streams category of APIs, the channel is the focal point of the request, and the objects and users are the filtering aspects. See the Enums Section for available channels and their CommBox code."
},
{
"name": "Tags",
"description": "
Tags are a classification tool for summarizing aspects of the conversation or the user. It can mark the conversation to indicate a new sale or identify a customer as not interested in the product. To help manage the Tags assets, Tags can be grouped with a common identifier."
},
{
"name": "SMS",
"description": "
Sending customers **SMS messages** (Texting) requires an initial opt-in step, which is not offered by CommBox and is the sole responsibility of the sending entity (Business)."
},
{
"name": "WhatsApp",
"description": "
CommBox facilitates activities in **WABA** for the clients. Our platform helps clients create new templates and manage existing ones.
**Opt-in for WhatsApp**
Before sending WhatsApp messages to someone, you must first receive opt-in permission confirming that they wish to receive future messages from you on WhatsApp. This can be done using any channel your business uses to communicate with people — your website, app, email, retail location, etc.
- The opt-in must be an active opt-in, which means it must be triggered by a user action, such as entering a phone number or checking a box to indicate consent.
- The opt-in must clearly state your business’ name.
- Clear opt-in messaging so that the customers know what type(s) of messaging they are signing up for.
For more information, please visit: https://developers.facebook.com/docs/whatsapp/guides/opt-in/"
},
{
"name": "Campaigns",
"description": "Send WhatsApp campaigns via an API. Campaigns are reflected in the metrics page in the platform."
},
{
"name": "Users",
"description": "
**Users** are people recorded in CommBox and they include both the business side and the customers.
Managers are APIs that deal with the business personas such as Admins, Agents, Team leaders, etc., and they include **Profiles**, **Presence**, **Assignments**, **Notifications**, and **Teams** sub-categories.
General USERS"
},
{
"name": "Managers",
"description": "
The **MANAGERS** APIs category relates to activities involving the Admins, Team Leaders, Agents, and any other business-related persona. This category includes **Profiles**, **Presence**, **Assignments**, **Notifications**, and **Teams** sub-categories."
},
{
"name": "Profiles",
"description": "
**Profiles** relate to system permissions and enabled activities assigned to a group of agents (managers).
When looking for a specific user, the USER ID is required.
The profile ID is required when selecting a specific profile (See Enum section)."
},
{
"name": "Presence",
"description": "
The Presence APIs relate to the agent availability status. Active and ready for assignment, Busy, or Away from the desk. Additional statuses can be created by the admin."
},
{
"name": "Assignments",
"description": "
The **Assignments** category relates to conversations (Objects) assigned to a specific agent."
},
{
"name": "Teams",
"description": "A Team is a group of agents with specific business agendas, roles, and permissions. Admins and Team Managers can set up Team Managers to create and manage teams and give those teams specific inbox filters, tags, and knowledge-based assets."
},
{
"name": "Audiences",
"description": "The Audiences APIs allow the creation, editing and listing of organizational audiences used for campaigns."
},
{
"name": "Forms",
"description": "The Forms APIs allow agents to assist customers in completing and signing forms issued by the organization. Once the customer submits the form, a new object is created that includes a link to the original conversation and stores the completed, signed form as an attachment."
},
{
"name": "Authentication",
"description": "Authentication APIs provide accessibility to the system."
},
{
"name": "Automation",
"description": "
Automation APIs are related to chatbot capabilities."
},
{
"name": "Transcription",
"description": "
**Transcription** turns a call recording into readable, speaker-attributed messages inside the conversation."
}
],
"x-tagGroups": [
{
"name": "API Calls",
"tags": [
"Core",
"Objects",
"Media",
"AI Services",
"Streams",
"Tags",
"SMS",
"WhatsApp",
"Users",
"Managers",
"Profiles",
"Presence",
"Assignments",
"Teams",
"Audiences",
"Forms",
"Authentication",
"Automation"
]
}
],
"paths": {
"/streams/{STREAM_ID}/objects/{OBJECT_ID}/child": {
"post": {
"tags": [
"Objects"
],
"summary": "Create Child Object",
"description": " This API creates a message (child) in a conversation (object) on behalf of the agent, sending it to the customer, or on behalf of the customer, displaying it to the agent.
The API returns the new child’s ID.
Required path parameters include the Stream (channel) ID and the Object (conversation) ID.
Required body parameters for a message on behalf of the customer:
a) The data “Type” see Enum at https://www.commbox.io/api/#section/Enums/ObjectType
b) UserStreamProviderId – the email or phone number of the person you are sending the message on their behalf.
c) UserStreamProviderType of the channel. See Enum at https://www.commbox.io/api/#section/Enums/StreamProviderType
d) The messages
Required body parameters for a message on behalf of the agent:
a) The data “Type” - See Enum at https://www.commbox.io/api/#section/Enums/ObjectType
b) Add this Boolean field 'IsManager': true,
c) Enter the agent’s user ID 'UserIdentity' : 34168,
Get the agent's User ID by using the Get Managers API https://api.commbox.io/managers
d) UserStreamProviderId – the email or phone number of the person you are sending the message on their behalf.
e) UserStreamProviderType of the channel. See Enum at https://www.commbox.io/api/#section/Enums/StreamProviderType
f) The messages
**Note:** After 24 hours from last sent message, APIs messages sent to customers will be blocked by WhatsApp.
POST /streams/STREAM_ID/objects/OBJECT_ID/child
POST /streams/STREAM_ID/objects/STREAM_PROVIDER_ID/STREAM_PROVIDER_TYPE/child",
"operationId": "Create_Child_Object",
"parameters": [
{
"name": "STREAM_ID",
"in": "path",
"description": "The unique identifier for the stream (CommBox channel)",
"required": true,
"schema": {
"$ref": "#/components/parameters/STREAM_ID/schema"
}
},
{
"name": "OBJECT_ID",
"in": "path",
"description": "The unique identifier for the object (CommBox conversation)",
"required": true,
"schema": {
"$ref": "#/components/parameters/OBJECT_ID/schema"
}
}
],
"requestBody": {
"description": "Payload containing child object information",
"required": true,
"content": {
"application/json": {
"schema": {
"$ref": "#/components/schemas/Object_Child"
},
"examples": {
"On behalf of Agent - Sending an email": {
"value": {
"data": {
"IsManager": true,
"UserIdentity": 36574658,
"Type": 4,
"UserStreamProviderId": "best.agent@commbox.com",
"UserStreamProviderType": 4,
"Message": "A new message on behalf of the agent"
}
}
},
"On behalf of Agent - Sending a WhatsApp message": {
"value": {
"data": {
"IsManager": true,
"UserIdentity": 36574658,
"Type": 4,
"UserStreamProviderId": "972542660000",
"UserStreamProviderType": 7,
"Message": "A new message on behalf of the agent"
}
}
},
"On behalf of Customer": {
"value": {
"data": {
"Type": 4,
"UserStreamProviderId": "MrDoe@gmail.com",
"UserStreamProviderType": 4,
"Message": "A message on behalf of Mr. John Doe"
}
}
}
}
}
}
},
"responses": {
"200": {
"description": "OK",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"status": {
"type": "integer",
"example": 200
},
"description": {
"type": "string",
"example": "OK"
},
"response_time": {
"type": "string",
"example": "2024-08-06T07:51:52.2581942Z"
},
"data": {
"type": "object",
"properties": {
"id": {
"type": "integer",
"example": 294159
}
}
}
}
}
}
}
},
"400": {
"description": "Bad Request - The request could not be understood by the server. Incoming parameters might not be valid",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"status": {
"type": "integer",
"example": 400
},
"description": {
"type": "string",
"example": "Bad Request"
},
"response_time": {
"type": "string",
"format": "date-time"
}
}
}
}
}
},
"401": {
"description": "Unauthorized - The supplied credentials, if any, are not sufficient to access the resource",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"status": {
"type": "integer",
"example": 401
},
"description": {
"type": "string",
"example": "Unauthorized access"
},
"response_time": {
"type": "string",
"format": "date-time"
}
}
}
}
}
},
"404": {
"description": "Not Found - The requested resource is not found",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"status": {
"type": "integer",
"example": 404
},
"description": {
"type": "string",
"example": "Not found"
},
"response_time": {
"type": "string",
"format": "date-time"
}
}
}
}
}
},
"429": {
"description": "Too Many Requests - Too many requests have been made in a short period of time (Throttling)",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"status": {
"type": "integer",
"example": 429
},
"description": {
"type": "string",
"example": "Too Many Requests"
},
"response_time": {
"type": "string",
"format": "date-time"
}
}
}
}
}
},
"500": {
"description": "Internal Server Error - The server could not return the representation due to an internal server error",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"status": {
"type": "integer",
"example": 500
},
"description": {
"type": "string",
"example": "Operation failed"
},
"response_time": {
"type": "string",
"format": "date-time"
}
}
},
"example": {
"status": 500,
"description": "Operation failed",
"response_time": "2025-04-15T07:24:52.956691Z"
}
}
}
},
"501": {
"description": "Not Implemented - The requested operation is not supported"
}
}
}
}
},
"components": {
"schemas": {
"Object_Child": {
"type": "object",
"properties": {
"type": {
"type": "integer",
"format": "int64",
"description": "The type of the object. See Enum"
},
"IsManager": {
"type": "boolean",
"description": "Indicates whether the message is from the agent or admin (true) or from a customer (false)"
},
"UserIdentity": {
"type": "integer",
"description": "Enter the agent's user ID. Ignore when creating customer's message. Get the agent's User ID by using the Get Managers API"
},
"UserStreamProviderId": {
"type": "string",
"description": "The email or phone number of the person you are sending the message on their behalf"
},
"UserStreamProviderType": {
"type": "integer",
"description": "The channel type’s code. See Enum "
},
"Message": {
"type": "string",
"description": "The message on behalf of the agent / customer"
}
}
}
},
"securitySchemes": {
"BearerAuth": {
"type": "http",
"scheme": "bearer",
"description": "API key is needed to authorize requests. You can get your API key via the management console. A Bearer Token is needed to be set in the Authorization header of every API call. For additional support you can contact us."
}
}
}
}
````